`rgeomcmc` <-
function(ini, y, mdist, nmc=100,
                     tun=rep(1,3), verbose=0) {
  acc <- rep(0, 3)
  mtun <- mc <- matrix(NA, nmc, 3)
  mtun[1, ] <- tun
  mc[1,] <- ini
  post.old <- postgeo(ini, y, mdist) 
  for (i in 2:nmc){
    mu.new <- rnorm(1, mc[i-1, 1], mtun[i-1,1])
    post.new <- postgeo(c(mu.new, mc[i-1, 2:3]), y, mdist)
    rpost <- post.new - post.old
    if (rpost > log(runif(1))) {
      acc[1] <- acc[1] + 1
      mc[i, 1] <- mu.new
      post.old <- post.new
    }
    else
      mc[i, 1] <- mc[i-1, 1]
    v.new <- rlnorm(1, log(mc[i-1, 2]), mtun[i-1,2])
    post.new <- postgeo(c(mc[i, 1], v.new, mc[i-1, 3]), y, mdist)
    rpost <- post.new - post.old
    if (rpost > log(runif(1))) {
      acc[2] <- acc[2] + 1
      mc[i, 2] <- v.new
      post.old <- post.new
    }
    else
      mc[i, 2] <- mc[i-1, 2]
    phi.new <- rlnorm(1, log(mc[i-1, 3]), mtun[i-1,3])
    post.new <- postgeo(c(mc[i, 1:2], phi.new), y, mdist)
    rpost <- post.new - post.old
    if (rpost > log(runif(1))) {
      acc[3] <- acc[3] + 1
      mc[i, 3] <- phi.new
      post.old <- post.new
    }
    else
      mc[i, 3] <- mc[i-1, 3]
    mtun[i,] <- mtun[i-1,]
    if (i%%10==0) {
      for (k in 1:3) {
        if (acc[k]/i>.40)
        mtun[i, k] <- mtun[i-1, k]*1.2
        if (acc[k]/i<.25)
          mtun[i, k] <- mtun[i-1, k]/1.2
      }
    }
    if (verbose && (i%%verbose)==0)
      cat(i, post.new, rpost, mc[i,], acc/i, "\n")
  }
  colnames(mtun) <- colnames(mc) <- c("beta", "sigmasq", "phi")
  return(list(mcmc=mc, tune=mtun, acc=acc))
}

